(*

DO NOT CHANGE THIS SCRIPT! CREATE YOUR OWN VERSION AND SAVE IT WITH A DIFFERENT NAME! Thank you!

*)
global debugFlag

on run (argv)
	
	set debugFlag to false # change before deploying!!
	
	if (debugFlag is false) then
		(* Plausibility check *)
		if (count of argv) is less than 1 then return 1
		
		(* Get argument #1, should be the tempfile with the selected image urls *)
		set listOfSelectedFilePathsTempFile to first item of argv
		
		(* Get the file urls *)
		set listOfSelectedFilePathsString to readUTF16File(listOfSelectedFilePathsTempFile)
	else
		set listOfSelectedFilePathsString to readUTF16File("/Users/heiko/Desktop/foo4.txt")
		#		set listOfSelectedFilePathsString to "/Users/heiko/Pictures/ct_logo.gif" (* if we're debugging, open one file from my disk ... *)
	end if
	
	(* Walk through the urls *)
	set listOfSelectedFilePathsList to every paragraph of listOfSelectedFilePathsString
	repeat with oneURL in listOfSelectedFilePathsList
		
		#display dialog "Processing file \"" & oneURL & "\"!" buttons {"Go on!"}
		my NSLog("Processing file \"" & oneURL & "\"!")
		if (fileExists(oneURL)) then # and length of oneURL is not 0) then
			
			(* Determine new filename *)
			set newSuffix to "psd"
			tell me to set containingFolder to pathOfFilePath(oneURL)
			tell me to set oneNewURL to containingFolder & "/" & fileNameWithoutSuffix(fileOfFilePath(oneURL)) & "." & newSuffix
			log "oneNewURL: " & oneNewURL
			
			(* File already exists? *)
			if (fileExists(oneNewURL)) then
				tell application "Finder"
					activate
					display dialog "Sorry, can't create \"" & newSuffix & "\" version of selected file \"" & oneURL & "\" because it aready exists." buttons {"I see"}
				end tell
			else
				(* open w/ PS *)
				tell application "Adobe Photoshop CS3"
					activate
					open file oneURL
					#				open file oneURL
					#duplicate document 1
					#close document 1
					tell document 1
						#save as JPEG in containingFolder without copying
						#save in containingFolder as JPEG without copying (* NO GOOD IDEA! Not every format can be saved as JPEG without modifications!! *)
						save in containingFolder as Photoshop format without copying
						close saving no
					end tell
				end tell
			end if
		else
			log "The file \"" & oneURL & "\" doesn't exist! Skipping."
		end if
		
	end repeat
	
	(* While Soraya is executing (not threaded) it can't be activated... 
	if (debugFlag is false) then
		tell application "Soraya" to activate
	end if*)
	
	(* Get back to Soraya by Hiding Photoshop! *)
	tell application "System Events"
		set visible of process "Adobe Photoshop CS3" to false
	end tell
	#	tell application "System Events" (* Just in case *)
	#		set visible of process "Soraya"" to true
	#	end tell
	
	return 0
end run


on readUTF16File(unixPath) # http://stackoverflow.com/questions/4981598/how-to-create-and-write-utf-16-text-file-using-applescript
	try
		set openFile to open for access POSIX file unixPath
		set theText to read openFile as Unicode text
		close access openFile
	on error
		try
			close access file targetFile
		end try
		return false
	end try
	return theText as string
end readUTF16File

on fileExists(posixPath)
	set res to false
	log "posixPath: " & posixPath
	try
		tell AppleScript
			set theFile to POSIX file posixPath (* Das geht immer! *)
			set a to theFile as alias (* Das nur, wenn das file existiert! *)
		end tell
		set res to true
	end try
	log "file \"" & posixPath & "\" exists? " & (res as string)
	return res
end fileExists



on fileOfFilePath(filePath)
	
	(* Text-Liste in echte Liste umwandeln *)
	set oldAST to AppleScript's text item delimiters
	set AppleScript's text item delimiters to "/"
	set elements to text items of filePath
	set AppleScript's text item delimiters to oldAST
	
	
	set res to last item of elements
	log "fileOfFilePath: " & res
	return res
end fileOfFilePath



on pathOfFilePath(filePath)
	# http://developer.apple.com/documentation/applescript/conceptual/applescriptlangguide/index.html
	# http://macscripter.net/viewtopic.php?id=24525
	
	(* Text-Liste in echte Liste umwandeln *)
	set oldAST to AppleScript's text item delimiters
	set AppleScript's text item delimiters to "/"
	set elements to text items of filePath
	
	set elememtsminuseins to items 1 thru ((count of items in elements) - 1) of elements
	
	set res to elememtsminuseins as text
	set AppleScript's text item delimiters to oldAST
	
	log "pathOfFilePath: " & res
	return res
end pathOfFilePath

on fileNameSuffix(fileName)
	set oldAST to AppleScript's text item delimiters
	set AppleScript's text item delimiters to "."
	set elements to text items of fileName
	set AppleScript's text item delimiters to oldAST
	set res to last item of elements
	log "fileNameSuffix: " & res
	return res
end fileNameSuffix


on fileNameWithoutSuffix(fileName)
	set oldAST to AppleScript's text item delimiters
	set AppleScript's text item delimiters to "."
	set elements to text items of fileName
	set AppleScript's text item delimiters to oldAST
	#set res to last item of elements
	set res to items 1 thru ((count of items in elements) - 1) of elements
	log "fileNameWithoutSuffix: " & res
	return res
end fileNameWithoutSuffix



on NSLog(message)
	
	try
		log message
		do shell script ("syslog -s -l Notice \"" & message & "\"")
	on error (e)
		log e
		
	end try
end NSLog